namespace eval Image2Mesh {
    variable version 0.1 ;#UNV plugin version
    variable CWD [file dirname [info script]]
}

proc Image2Mesh::getExe { } {
    variable CWD
    
    set bitSize [expr {$::tcl_platform(pointerSize)*8}]
    if {$::tcl_platform(platform) eq "windows"} {
	set ext ".exe"
	set OS "Windows"
    } else {
	set ext ""
	set OS $::tcl_platform(os)
    }
    return [file join $CWD bin "${OS}.${bitSize}" ImportMatImage$ext]
}

proc Image2Mesh::DoTest { imgInput roi } {
    DoImportImage -input $imgInput -roi $roi
}

if {0} {
    -input /home/jorge/GID/bitbucket/Test_GID/models/Mesh/MeshFromFile/MeshFrom3DImage/LAM72_2.tif -roi 844 239 108 104
Num. of Linear elements=2.408
Num. of Quadrilateral elements=48
Num. of Tetrahedra elements=241.623
Num. of Hexahedra elements=1
Num. of nodes=44.820
}

proc Image2Mesh::CmdImportImage { } {
    DoImportImage {*}[ImportImg2Mat::Show]
}

proc Image2Mesh::DoImportImage { args } {
    variable CWD
    
    array set data $args
    
    set randID [expr int(ceil(rand()*100000))]
    set fileOutput [file join [ImportImg2Mat::GetTmpDir] "ImportImg2Mat_${randID}-[pid].vtk"]
    if {![info exists data(-input)]} {
	return
    } 
    set cmd [list [getExe] [lindex $data(-input) 0] $fileOutput]
    if {[info exists data(-roi)]} {
	#WarnWinText $data(-roi)
	lappend cmd {*}$data(-roi)
    }
    catch {
	exec {*}$cmd
    } result
    if {[file exists $fileOutput]} {
	# save status variable
	set backupVolumeMesher [GiD_Set VolumeMesher]
	# modify status variable
	GiD_Set VolumeMesher 3
	# remove previous mesh
	if {[GiD_Info Mesh NumElements] > 0} {
	    # TODO: ASK BEFORE ERASING!!!!
	    GiD_Process MEscape Meshing CancelMesh Yes MEscape
	}
	set status [catch {
	    GiD_Process MEscape Meshing MeshFromFile $fileOutput escape
	} msg]
	file delete $fileOutput
	# restore status variable
	GiD_Set VolumeMesher $backupVolumeMesher
	if {$status} {
	    error $msg
	}
	if { [GiD_Info project ViewMode] != "MESHUSE" && [lindex [GiD_Info Mesh] 0]>0} {
	    GiD_Process MEscape Meshing MeshView escape
	}
    } else {
	error $result
    }
}

proc Image2Mesh::AddToMenu { } {
    if { [GidUtils::IsTkDisabled] } {
	return
    }
    if { [GiDMenu::GetOptionIndex Files [list Import "Image2Mesh..."] PRE] != -1 } {
	return
    }
    
    #try to insert this menu after the word "Files->Import->XYZ nodes"
    set position [GiDMenu::GetOptionIndex Files [list Import "XYZ nodes"] PRE]
    if { $position == -1 } {
	set position end
    }
    GiDMenu::InsertOption Files [list Import "Image2Mesh..."] $position PRE Image2Mesh::CmdImportImage "" "" insertafter _
}

#invoke this menus changes
Image2Mesh::AddToMenu
GiDMenu::UpdateMenus

#register the proc to be automatically called when re-creating all menus (e.g. when doing files new)
GiD_RegisterPluginAddedMenuProc Image2Mesh::AddToMenu

lappend ::auto_path [file join $Image2Mesh::CWD lib]
source [file join $Image2Mesh::CWD ImportImg2Mat.tcl]
